/*

    This file is a part of the GLAMMAR source distribution 
    and therefore subjected to the copy notice below. 
    
    Copyright (C) 1989,1990  Eric Voss, ericv@cs.kun.nl 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 1

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include "ge1.h"
#ifdef UVALUEOF 
void uvalueof () 
{ 
   register cont *rq = q;
register AFFIX A_2 = rq->a;
register AFFIX A_1 = (rq -1)->a;
register AFFIX A_0 = (rq -2)->a;
   char *rc = c; 
   if ( dvalueof (A_0, A_1, A_2)) {
      q = rq -4;
      (*(rq -3)->q)(); 
      rq = q +3;
   }
   (rq -2)->a = A_0;
   (rq -1)->a = A_1;
   rq->a = A_2;
   (rq + 1)->q = uvalueof; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef ULOOKUP 
void ulookup () 
{ 
   register cont *rq = q;
register AFFIX A_2 = rq->a;
register AFFIX A_1 = (rq -1)->a;
register AFFIX A_0 = (rq -2)->a;
   char *rc = c; 
   if ( dlookup (A_0, A_1, A_2)) {
      q = rq -4;
      (*(rq -3)->q)(); 
      rq = q +3;
   }
   (rq -2)->a = A_0;
   (rq -1)->a = A_1;
   rq->a = A_2;
   (rq + 1)->q = ulookup; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UINCLUDES 
void uincludes () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( dincludes (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = uincludes; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UEXCLUDES 
void uexcludes () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( !dincludes (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = uexcludes; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UPAIR 
void upair () 
{ 
   register cont *rq = q;
register AFFIX A_2 = rq->a;
register AFFIX A_1 = (rq -1)->a;
register AFFIX A_0 = (rq -2)->a;
   char *rc = c; 
   if ( dpair (A_0, A_1, A_2)) {
      q = rq -4;
      (*(rq -3)->q)(); 
      rq = q +3;
   }
   (rq -2)->a = A_0;
   (rq -1)->a = A_1;
   rq->a = A_2;
   (rq + 1)->q = upair; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UUNPAIR 
void uunpair () 
{ 
   register cont *rq = q;
register AFFIX A_2 = rq->a;
register AFFIX A_1 = (rq -1)->a;
register AFFIX A_0 = (rq -2)->a;
   char *rc = c; 
   if ( dunpair (A_0, A_1, A_2)) {
      q = rq -4;
      (*(rq -3)->q)(); 
      rq = q +3;
   }
   (rq -2)->a = A_0;
   (rq -1)->a = A_1;
   rq->a = A_2;
   (rq + 1)->q = uunpair; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UWHERE 
void uwhere () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( dwhere (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = uwhere; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef UCOMPUTE 
void ucompute () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( dcompute (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = ucompute; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

#ifdef USIZE 
void usize () 
{ 
   register cont *rq = q;
register AFFIX A_1 = rq->a;
register AFFIX A_0 = (rq -1)->a;
   char *rc = c; 
   if ( dsize (A_0, A_1)) {
      q = rq -3;
      (*(rq -2)->q)(); 
      rq = q +2;
   }
   (rq -1)->a = A_0;
   rq->a = A_1;
   (rq + 1)->q = usize; 
   q = rq + 1; 
   c = rc;
  if (rc > cstore_top ) cstore_overflow();
}
#endif

