typedef int num;

#define charNIL (char)0
#define numNIL 0

/* ---- start of /usr/scratch/lib/cal.ht ---- */
/* Definition C datastructures (Version for array list).

   template file:      /usr/scratch/lib/cal.ht
   datastructure file: glue.ds
   tm version:         27 (Mon Nov 5 13:53:34 EST 1990)
 */

typedef struct str_actionspec_list *actionspec_list;
typedef struct str_menparspec_list *menparspec_list;
typedef struct str_menuitemspec_list *menuitemspec_list;
typedef struct str_paritemspec_list *paritemspec_list;
typedef struct str_string_list *string_list;
typedef struct str_gluefile *gluefile;
typedef struct str_Glue *Glue;
typedef struct str_menparspec *menparspec;
typedef struct str_Menu *Menu;
typedef struct str_Parset *Parset;
typedef struct str_menuitemspec *menuitemspec;
typedef struct str_actionspec *actionspec;
typedef struct str_Do *Do;
typedef struct str_Show *Show;
typedef struct str_Sys *Sys;
typedef struct str_Ask *Ask;
typedef struct str_Tofile *Tofile;
typedef struct str_paritemspec *paritemspec;
typedef struct str_typespec *typespec;
typedef struct str_Boolean *Boolean;
typedef struct str_Integer *Integer;
typedef struct str_Real *Real;
typedef struct str_String *String;
typedef struct str_Enum *Enum;

#define gluefileNIL (gluefile)0
#define menparspecNIL (menparspec)0
#define menuitemspecNIL (menuitemspec)0
#define actionspecNIL (actionspec)0
#define paritemspecNIL (paritemspec)0
#define typespecNIL (typespec)0
#define actionspec_listNIL (actionspec_list)0
#define menparspec_listNIL (menparspec_list)0
#define menuitemspec_listNIL (menuitemspec_list)0
#define paritemspec_listNIL (paritemspec_list)0
#define string_listNIL (string_list)0

typedef enum en_tags_gluefile {
    TAGGlue
} tags_gluefile;

typedef enum en_tags_menparspec {
    TAGMenu, TAGParset
} tags_menparspec;

typedef enum en_tags_actionspec {
    TAGDo, TAGShow, TAGSys, TAGAsk, TAGTofile
} tags_actionspec;

typedef enum en_tags_typespec {
    TAGBoolean, TAGInteger, TAGReal, TAGString, TAGEnum
} tags_typespec;


struct str_gluefile {
	tags_gluefile tag;
};

struct str_Glue {
	tags_gluefile tag;
	menparspec_list specs;
};

struct str_menparspec {
	tags_menparspec tag;
};

struct str_Menu {
	tags_menparspec tag;
	num menuid;
	string menuname;
	menuitemspec_list menuitems;
};

struct str_Parset {
	tags_menparspec tag;
	num parsetid;
	string parsetname;
	paritemspec_list parsetitem;
};

struct str_menuitemspec {
	string itemname;
	num linpos;
	char idchar;
	num idpos;
	actionspec_list action;
};

struct str_actionspec {
	tags_actionspec tag;
};

struct str_Do {
	tags_actionspec tag;
	num actionno;
};

struct str_Show {
	tags_actionspec tag;
	num menuid;
};

struct str_Sys {
	tags_actionspec tag;
	string command;
};

struct str_Ask {
	tags_actionspec tag;
	num parid;
};

struct str_Tofile {
	tags_actionspec tag;
	num parid;
	string filename;
};

struct str_paritemspec {
	string parname;
	string parshellname;
	string pardefault;
	char idchar;
	num idpos;
	typespec partype;
};

struct str_typespec {
	tags_typespec tag;
};

struct str_Boolean {
	tags_typespec tag;
};

struct str_Integer {
	tags_typespec tag;
};

struct str_Real {
	tags_typespec tag;
};

struct str_String {
	tags_typespec tag;
};

struct str_Enum {
	tags_typespec tag;
	string_list enumvals;
};

struct str_actionspec_list {
	unsigned int sz;
	unsigned int room;
	actionspec *arr;
};

struct str_menparspec_list {
	unsigned int sz;
	unsigned int room;
	menparspec *arr;
};

struct str_menuitemspec_list {
	unsigned int sz;
	unsigned int room;
	menuitemspec *arr;
};

struct str_paritemspec_list {
	unsigned int sz;
	unsigned int room;
	paritemspec *arr;
};

struct str_string_list {
	unsigned int sz;
	unsigned int room;
	string *arr;
};

/* new_<cons> and new_<type>routines */
extern menuitemspec new_menuitemspec();
extern actionspec_list new_actionspec_list();
extern string_list new_string_list();

/* room_<type>_list() routines */

/* app_<type>_list() routines */
extern void app_menuitemspec_list();
extern void app_actionspec_list();
extern void app_string_list();

/* ins_<type>_list() routines */

/* del_<type>_list() routines */

/* conc_<type>_list() routines */

/* fre_<type>_list() routines */

/* rfre_<type>_list() routines */

/* print_<type>() routines */
extern void print_gluefile();
extern void print_string_list();

/* fprint_<type>() routines */

/* rdup_<type>() routines */

/* fscan_<type>() routines */
extern int fscan_gluefile();
extern int fscan_string_list();

/* cmp_<type>() routines */

/* misc. functions */

/* ---- end of /usr/scratch/lib/cal.ht ---- */

