/* 
   Copyright (C) 1990 C van Reewijk, email: dutentb.uucp!reeuwijk

This file is part of GLASS.

GLASS is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GLASS is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GLASS; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* File: fsccbrac.c
 * Last modified: CvR
 *
 * Handling of close brackets around constructors and lists.
 */

/* Standard UNIX libraries. */
#include <stdio.h>
#include <ctype.h>

/* The header of this library */
#include "tmc.h"
#include "config.h"

#define CLOSEBRAC ')'

/* Skip all `isspace()' characters, and try to read `n' close
 * brackets. Give an error if this is not possible.
 */
int fscanclosebrac( f, n )
 FILE *f;
 int n;
{
    while( n>0 ){
        if( tmfneedc( f, CLOSEBRAC ) ) return( 1 );
	n--;
    }
    return( 0 );
}
